/**
  jBPM persistence
*/

CREATE GENERATOR HIBERNATE_SEQUENCE;
SET GENERATOR HIBERNATE_SEQUENCE TO 0;

CREATE GENERATOR SESSIONINFO_ID_SEQ;
SET GENERATOR SESSIONINFO_ID_SEQ TO 0;

CREATE GENERATOR WORKITEMINFO_ID_SEQ;
SET GENERATOR WORKITEMINFO_ID_SEQ TO 0;

CREATE GENERATOR I18NTEXT_ID_SEQ;
SET GENERATOR I18NTEXT_ID_SEQ TO 0;

CREATE GENERATOR CONTENT_ID_SEQ;
SET GENERATOR CONTENT_ID_SEQ TO 0;

CREATE GENERATOR EMAILNOTIFHEAD_ID_SEQ;
SET GENERATOR EMAILNOTIFHEAD_ID_SEQ TO 0;

CREATE GENERATOR ESCALATION_ID_SEQ;
SET GENERATOR ESCALATION_ID_SEQ TO 0;

CREATE GENERATOR NOTIFICATION_ID_SEQ;
SET GENERATOR NOTIFICATION_ID_SEQ TO 0;

CREATE GENERATOR REASSIGNMENT_ID_SEQ;
SET GENERATOR REASSIGNMENT_ID_SEQ TO 0;

CREATE GENERATOR WORKITEMINFO_ID_SEQ;
SET GENERATOR WORKITEMINFO_ID_SEQ TO 0;

CREATE GENERATOR COMMENT_ID_SEQ;
SET GENERATOR COMMENT_ID_SEQ TO 0;


CREATE TABLE ATTACHMENT (
    ID                       D_ID NOT NULL,
    ACCESSTYPE               D_INTEGER,
    ATTACHEDAT               TIMESTAMP,
    ATTACHMENTCONTENTID      D_ID NOT NULL,
    CONTENTTYPE              D_VARCHAR_252,
    NAME                     D_VARCHAR_252,
    ATTACHMENT_SIZE          D_INTEGER,
    ATTACHEDBY_ID            D_VARCHAR_252,
    TASKDATA_ATTACHMENTS_ID  D_ID
);
ALTER TABLE ATTACHMENT ADD CONSTRAINT PK_ATTACHMENT PRIMARY KEY (ID);

CREATE TABLE CONTENT (
    ID       D_ID NOT NULL,
    CONTENT  D_BLOB
);
ALTER TABLE CONTENT ADD CONSTRAINT PK_CONTENT PRIMARY KEY (ID);

CREATE TABLE DEADLINE (
    ID                          D_ID NOT NULL,
    DEADLINE_DATE               TIMESTAMP,
    ESCALATED                   D_SMALLINT NOT NULL,
    DEADLINES_STARTDEADLINE_ID  D_ID,
    DEADLINES_ENDDEADLINE_ID    D_ID
);
ALTER TABLE DEADLINE ADD CONSTRAINT PK_DEADLINE PRIMARY KEY (ID);

CREATE TABLE DELEGATION_DELEGATES (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE EMAIL_HEADER (
    ID              D_ID NOT NULL,
    BODY            D_NOTE,
    FROMADDRESS     D_VARCHAR_252,
    LANGUAGE        D_VARCHAR_252,
    REPLYTOADDRESS  D_VARCHAR_252,
    SUBJECT         D_VARCHAR_252
);
ALTER TABLE EMAIL_HEADER ADD PRIMARY KEY (ID);

CREATE TABLE ESCALATION (
    ID                      D_ID NOT NULL,
    NAME                    D_VARCHAR_252,
    DEADLINE_ESCALATION_ID  D_ID
);
ALTER TABLE ESCALATION ADD CONSTRAINT PK_ESCALATION PRIMARY KEY (ID);

CREATE TABLE EVENTTYPES (
    INSTANCEID  D_ID NOT NULL,
    ELEMENT     D_VARCHAR_252,
    EVENTTYPES  D_VARCHAR_252
);

CREATE TABLE I18NTEXT (
    ID                             D_ID NOT NULL,
    LANGUAGE                       D_VARCHAR_252,
    TEXT                           D_NOTE,
    TASK_SUBJECTS_ID               D_ID,
    TASK_NAMES_ID                  D_ID,
    TASK_DESCRIPTIONS_ID           D_ID,
    REASSIGNMENT_DOCUMENTATION_ID  D_ID,
    NOTIFICATION_SUBJECTS_ID       D_ID,
    NOTIFICATION_NAMES_ID          D_ID,
    NOTIFICATION_DOCUMENTATION_ID  D_ID,
    NOTIFICATION_DESCRIPTIONS_ID   D_ID,
    DEADLINE_DOCUMENTATION_ID      D_ID,
    SHORTTEXT                      D_VARCHAR_252
);
ALTER TABLE I18NTEXT ADD CONSTRAINT PK_I18NTEXT PRIMARY KEY (ID);

CREATE TABLE NOTIFICATION (
    DTYPE                        D_VARCHAR_34 NOT NULL,
    ID                           D_ID NOT NULL,
    PRIORITY                     D_INTEGER NOT NULL,
    ESCALATION_NOTIFICATIONS_ID  D_ID
);
ALTER TABLE NOTIFICATION ADD CONSTRAINT PK_NOTIFICATION PRIMARY KEY (ID);

CREATE TABLE NOTIFICATION_BAS (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE NOTIFICATION_EMAIL_HEADER (
    NOTIFICATION_ID  D_ID NOT NULL,
    EMAILHEADERS_ID  D_ID NOT NULL,
    MAPKEY           D_VARCHAR_252 NOT NULL
);
ALTER TABLE NOTIFICATION_EMAIL_HEADER ADD CONSTRAINT UQ_NOT_EMAIL_HEADER_EH UNIQUE (EMAILHEADERS_ID);
ALTER TABLE NOTIFICATION_EMAIL_HEADER ADD CONSTRAINT PK_NOTIFICATION_EMAIL_HEADER PRIMARY KEY (NOTIFICATION_ID, MAPKEY);

CREATE TABLE NOTIFICATION_RECIPIENTS (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE ORGANIZATIONALENTITY (
    DTYPE  VARCHAR(31) NOT NULL,
    ID     D_VARCHAR_252 NOT NULL
);
ALTER TABLE ORGANIZATIONALENTITY ADD CONSTRAINT PK_ORGANIZATIONALENTITY PRIMARY KEY (ID);

CREATE TABLE PEOPLEASSIGNMENTS_BAS (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE PEOPLEASSIGNMENTS_EXCLOWNERS (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE PEOPLEASSIGNMENTS_POTOWNERS (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE PEOPLEASSIGNMENTS_RECIPIENTS (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE PEOPLEASSIGNMENTS_STAKEHOLDERS (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE PROCESSINSTANCEEVENTINFO (
    ID                 D_ID NOT NULL,
    EVENTTYPE          D_VARCHAR_252,
    PROCESSINSTANCEID  D_ID NOT NULL,
    OPTLOCK            D_INTEGER
);
ALTER TABLE PROCESSINSTANCEEVENTINFO ADD CONSTRAINT PK_PROCESSINSTANCEEVENTINFO PRIMARY KEY (ID);

CREATE TABLE PROCESSINSTANCEINFO (
    INSTANCEID                D_ID NOT NULL,
    LASTMODIFICATIONDATE      TIMESTAMP,
    LASTREADDATE              TIMESTAMP,
    PROCESSID                 D_VARCHAR_252,
    PROCESSINSTANCEBYTEARRAY  D_BLOB,
    STARTDATE                 TIMESTAMP,
    STATE                     D_INTEGER NOT NULL,
    OPTLOCK                   D_INTEGER
);
ALTER TABLE PROCESSINSTANCEINFO ADD CONSTRAINT PK_PROCESSINSTANCEINFO PRIMARY KEY (INSTANCEID);

CREATE TABLE REASSIGNMENT (
    ID                           D_ID NOT NULL,
    ESCALATION_REASSIGNMENTS_ID  D_ID
);
ALTER TABLE REASSIGNMENT ADD CONSTRAINT PK_REASSIGNMENT PRIMARY KEY (ID);

CREATE TABLE REASSIGNMENT_POTENTIALOWNERS (
    TASK_ID    D_ID NOT NULL,
    ENTITY_ID  D_VARCHAR_252 NOT NULL
);

CREATE TABLE SESSIONINFO (
    ID                    D_INTEGER NOT NULL,
    LASTMODIFICATIONDATE  TIMESTAMP,
    RULESBYTEARRAY        D_BLOB,
    STARTDATE             TIMESTAMP,
    OPTLOCK               D_INTEGER
);
ALTER TABLE SESSIONINFO ADD CONSTRAINT PK_SESSIONINFO PRIMARY KEY (ID);

CREATE TABLE SUBTASKSSTRATEGY (
    DTYPE    VARCHAR(100) NOT NULL,
    ID       D_ID NOT NULL,
    NAME     D_VARCHAR_252,
    TASK_ID  D_ID
);
ALTER TABLE SUBTASKSSTRATEGY ADD CONSTRAINT PK_SUBTASKSSTRATEGY PRIMARY KEY (ID);

CREATE TABLE TASK (
    ID                  D_ID NOT NULL,
    ALLOWEDTODELEGATE   D_VARCHAR_252,
    PRIORITY            D_INTEGER NOT NULL,
    ACTIVATIONTIME      TIMESTAMP,
    CREATEDON           TIMESTAMP,
    DOCUMENTACCESSTYPE  D_INTEGER,
    DOCUMENTCONTENTID   D_ID NOT NULL,
    DOCUMENTTYPE        D_VARCHAR_252,
    EXPIRATIONTIME      TIMESTAMP,
    FAULTACCESSTYPE     D_INTEGER,
    FAULTCONTENTID      D_ID NOT NULL,
    FAULTNAME           D_VARCHAR_252,
    FAULTTYPE           D_VARCHAR_252,
    OUTPUTACCESSTYPE    D_INTEGER,
    OUTPUTCONTENTID     D_ID NOT NULL,
    OUTPUTTYPE          D_VARCHAR_252,
    PARENTID            D_ID NOT NULL,
    PREVIOUSSTATUS      D_INTEGER,
    PROCESSINSTANCEID   D_ID NOT NULL,
    PROCESSID        D_VARCHAR_252,
    PROCESSSESSIONID    D_VARCHAR_252,
    SKIPABLE            D_SMALLINT NOT NULL,
    STATUS              D_VARCHAR_252,
    WORKITEMID          D_ID NOT NULL,
    TASKINITIATOR_ID    D_VARCHAR_252,
    ACTUALOWNER_ID      D_VARCHAR_252,
    CREATEDBY_ID        D_VARCHAR_252,
    OPTLOCK             D_INTEGER,
    ARCHIVED            D_SMALLINT,
    COMPLETEDON         TIMESTAMP
);
ALTER TABLE TASK ADD CONSTRAINT PK_TASK PRIMARY KEY (ID);

CREATE TABLE TASK_COMMENT (
    ID                    D_ID NOT NULL,
    ADDEDAT               TIMESTAMP,
    TEXT                  D_NOTE,
    ADDEDBY_ID            D_VARCHAR_252,
    TASKDATA_COMMENTS_ID  D_ID
);
ALTER TABLE TASK_COMMENT ADD CONSTRAINT PK_TASK_COMMENT PRIMARY KEY (ID);

CREATE TABLE WORKITEMINFO (
    WORKITEMID         D_ID NOT NULL,
    CREATIONDATE       TIMESTAMP,
    NAME               D_VARCHAR_252,
    PROCESSINSTANCEID  D_ID NOT NULL,
    STATE              D_ID NOT NULL,
    OPTLOCK            D_INTEGER,
    WORKITEMBYTEARRAY  D_BLOB
);
ALTER TABLE WORKITEMINFO ADD CONSTRAINT PK_WORKITEMINFO PRIMARY KEY (WORKITEMID);

ALTER TABLE ATTACHMENT ADD CONSTRAINT FK_ATT_ORG FOREIGN KEY (ATTACHEDBY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE ATTACHMENT ADD CONSTRAINT FK_ATT_TASK FOREIGN KEY (TASKDATA_ATTACHMENTS_ID) REFERENCES TASK (ID);
ALTER TABLE DEADLINE ADD CONSTRAINT FK_DEADLINEEND_TASK FOREIGN KEY (DEADLINES_ENDDEADLINE_ID) REFERENCES TASK (ID);
ALTER TABLE DEADLINE ADD CONSTRAINT FK_DEADLINESTART_TASK FOREIGN KEY (DEADLINES_STARTDEADLINE_ID) REFERENCES TASK (ID);
ALTER TABLE DELEGATION_DELEGATES ADD CONSTRAINT FK_DELEG_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE DELEGATION_DELEGATES ADD CONSTRAINT FK_DELEG_TASK FOREIGN KEY (TASK_ID) REFERENCES TASK (ID);
ALTER TABLE ESCALATION ADD CONSTRAINT FK_ESCALATION_DEADLINE FOREIGN KEY (DEADLINE_ESCALATION_ID) REFERENCES DEADLINE (ID);
ALTER TABLE EVENTTYPES ADD CONSTRAINT FK_EVENTTYPES_PROCINFO FOREIGN KEY (INSTANCEID) REFERENCES PROCESSINSTANCEINFO (INSTANCEID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_NAME_NOTIFICATION FOREIGN KEY (NOTIFICATION_NAMES_ID) REFERENCES NOTIFICATION (ID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_SUBJ_NOTIFICATION FOREIGN KEY (NOTIFICATION_SUBJECTS_ID) REFERENCES NOTIFICATION (ID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_DESC_NOTIFICATION FOREIGN KEY (NOTIFICATION_DESCRIPTIONS_ID) REFERENCES NOTIFICATION (ID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_DOC_NOTIFICATION FOREIGN KEY (NOTIFICATION_DOCUMENTATION_ID) REFERENCES NOTIFICATION (ID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_NAME_TASK FOREIGN KEY (TASK_NAMES_ID) REFERENCES TASK (ID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_DESC_TASK FOREIGN KEY (TASK_DESCRIPTIONS_ID) REFERENCES TASK (ID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_SUBJ_TASK FOREIGN KEY (TASK_SUBJECTS_ID) REFERENCES TASK (ID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_DEADLINE FOREIGN KEY (DEADLINE_DOCUMENTATION_ID) REFERENCES DEADLINE (ID);
ALTER TABLE I18NTEXT ADD CONSTRAINT FK_I18N_REASSIGNMENT FOREIGN KEY (REASSIGNMENT_DOCUMENTATION_ID) REFERENCES REASSIGNMENT (ID);
ALTER TABLE NOTIFICATION ADD CONSTRAINT FK_NOTIFICATION_ESC FOREIGN KEY (ESCALATION_NOTIFICATIONS_ID) REFERENCES ESCALATION (ID);
ALTER TABLE NOTIFICATION_BAS ADD CONSTRAINT FK2_NOT_BAS_NOT FOREIGN KEY (TASK_ID) REFERENCES NOTIFICATION (ID);
ALTER TABLE NOTIFICATION_BAS ADD CONSTRAINT FK2_NOT_BAS_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE NOTIFICATION_EMAIL_HEADER ADD CONSTRAINT FK_NOT_EMAIL_HEADER_EH FOREIGN KEY (EMAILHEADERS_ID) REFERENCES EMAIL_HEADER (ID);
ALTER TABLE NOTIFICATION_EMAIL_HEADER ADD CONSTRAINT FK_NOT_EMAIL_HEADER_NO FOREIGN KEY (NOTIFICATION_ID) REFERENCES NOTIFICATION (ID);
ALTER TABLE NOTIFICATION_RECIPIENTS ADD CONSTRAINT FK_NOT_RECIP_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE NOTIFICATION_RECIPIENTS ADD CONSTRAINT FK_NOT__RECIP_NOT FOREIGN KEY (TASK_ID) REFERENCES NOTIFICATION (ID);
ALTER TABLE PEOPLEASSIGNMENTS_BAS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_BAS_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE PEOPLEASSIGNMENTS_BAS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_BAS_TASK FOREIGN KEY (TASK_ID) REFERENCES TASK (ID);
ALTER TABLE PEOPLEASSIGNMENTS_EXCLOWNERS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_EXCL_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE PEOPLEASSIGNMENTS_EXCLOWNERS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_EXCL_TASK FOREIGN KEY (TASK_ID) REFERENCES TASK (ID);
ALTER TABLE PEOPLEASSIGNMENTS_POTOWNERS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_POT_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE PEOPLEASSIGNMENTS_POTOWNERS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_POT_TASK FOREIGN KEY (TASK_ID) REFERENCES TASK (ID);
ALTER TABLE PEOPLEASSIGNMENTS_RECIPIENTS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_REC_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE PEOPLEASSIGNMENTS_RECIPIENTS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_REC_TASK FOREIGN KEY (TASK_ID) REFERENCES TASK (ID);
ALTER TABLE PEOPLEASSIGNMENTS_STAKEHOLDERS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_STA_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE PEOPLEASSIGNMENTS_STAKEHOLDERS ADD CONSTRAINT FK_PEOPLEASSIGNMENTS_STA_TASK FOREIGN KEY (TASK_ID) REFERENCES TASK (ID);
ALTER TABLE REASSIGNMENT ADD CONSTRAINT FK_REASSIGNMENT_ESC FOREIGN KEY (ESCALATION_REASSIGNMENTS_ID) REFERENCES ESCALATION (ID);
ALTER TABLE REASSIGNMENT_POTENTIALOWNERS ADD CONSTRAINT FK_REASSIGNMENT_POT_ORG FOREIGN KEY (ENTITY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE REASSIGNMENT_POTENTIALOWNERS ADD CONSTRAINT FK_REASSIGNMENT_POT_REAS FOREIGN KEY (TASK_ID) REFERENCES REASSIGNMENT (ID);
ALTER TABLE SUBTASKSSTRATEGY ADD CONSTRAINT FK_SUBTASKSSTRATEGY_TASK FOREIGN KEY (TASK_ID) REFERENCES TASK (ID);
ALTER TABLE TASK ADD CONSTRAINT FK_TASK_OWNER_ORG FOREIGN KEY (ACTUALOWNER_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE TASK ADD CONSTRAINT FK_TASK_CREA_ORG FOREIGN KEY (CREATEDBY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE TASK ADD CONSTRAINT FK_TASK_INIT_ORG FOREIGN KEY (TASKINITIATOR_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE TASK_COMMENT ADD CONSTRAINT FK_TASK_COMMENT_ORG FOREIGN KEY (ADDEDBY_ID) REFERENCES ORGANIZATIONALENTITY (ID);
ALTER TABLE TASK_COMMENT ADD CONSTRAINT FK_TASK_COMMENT_TESK FOREIGN KEY (TASKDATA_COMMENTS_ID) REFERENCES TASK (ID);
